package com.sillycycle.bagleyd.ant3d;

/*
 * @(#)Ant3DInterface.java
 *
 * Copyright 1993 - 2019  David A. Bagley, bagleyd AT verizon.net
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * The <code>Ant3DInterface</code> class contains most of the
 * constants used by the <code>Ant3DFrame</code> class.
 *
 * @author	David A. Bagley
 * @author	bagleyd AT verizon.net
 * @author	https://www.sillycycle.com/life.html
 */

public final class Ant3DInterface {
	static final String LIFEFILE = "out.life";

	static final int EMPTY = -1;
	static final int DEFAULT_CELLSIZE = 12;
	static final int NEXT_CELLSIZE = 3;
	static final int MIN_SPEED = 1;
	static final int MAX_SPEED = 50;
	static final int DEFAULT_COLUMNS = 48;
	static final int DEFAULT_ROWS = 48;
	static final int DEFAULT_STACKS = 24;
	static final int MIN_COLUMNS = 7;
	static final int MIN_ROWS = 7;
	static final int MIN_STACKS = 4;
	static final int MAX_COLUMNS = 2 * DEFAULT_COLUMNS;
	static final int MAX_ROWS = 2 * DEFAULT_ROWS;
	static final int MAX_STACKS = 2 * DEFAULT_STACKS;
	static final int DEFAULT_SPEED = 40;
	static final int DEFAULT_NEIGHBOR_INDEX = 0; // For n=6
	static final char DEFAULT_ALIVE_CHAR = '*';
	static final char DEFAULT_DEAD_CHAR = '.';
	static final char[] DEAD_CHARS = {'.'};
	static final char[] ALIVE_CHARS = {'o', 'O','*', 'A', 'V', 'J', 'D'};
	static final String MSG_PAUSED = "Paused";
	static final int DEFAULT_EXCLUDE_COUNT = 1;
	static final int DEFAULT_SEARCH_COUNT = 72;
	static final int DEFAULT_EXCLUDE_PERIOD = 2;
	static final int DEFAULT_SEARCH_LENGTH = 300;

	static final String MSG_END = "Life Over";
	static final String TITLE = "Ant3D";
	public enum Icons {X16, X22, X24, X32, X48, X64}
	static final String[] ICONS = {"icons/16x16/ant3d.png",
		"icons/22x22/ant3d.png",
		"icons/24x24/ant3d.png",
		"icons/32x32/ant3d.png",
		"icons/48x48/ant3d.png",
		"icons/64x64/ant3d.png"};

	static boolean aliveChar(char c) {
		for (int i = 0; i < ALIVE_CHARS.length; i++) {
			if (ALIVE_CHARS[i] == c)
				return true;
		}
		return false;
	}

	static boolean deadChar(char c) {
		for (int i = 0; i < DEAD_CHARS.length; i++) {
			if (DEAD_CHARS[i] == c)
				return true;
		}
		return false;
	}
}
