package com.sillycycle.bagleyd.util;

/*
 * @(#)FiniteStateMachine.java
 *
 * Copyright 2010 - 2014  David A. Bagley, bagleyd AT verizon.net
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * The <code>Cell</code> class handles the construction of the cells.
 *
 * @author	David A. Bagley
 * @author	bagleyd AT verizon.net
 * @author	https://www.sillycycle.com/life.html
 */

public class FiniteStateMachine {
	private byte color;
	private short direction;
	private byte next;

	public FiniteStateMachine(byte color, short direction, byte next) {
		this.color = color;
		this.direction = direction;
		this.next = next;
	}

	public byte getColor() {
		return this.color;
	}

	void setColor(byte color) {
		this.color = color;
	}

	public short getDirection() {
		return this.direction;
	}

	void setDirection(short direction) {
		this.direction = direction;
	}

	public byte getNext() {
		return this.next;
	}

	void setNext(byte next) {
		this.next = next;
	}
}
